/*
	I take absolutely 0 credit for this. All of this was made by Pyrakid with help from others. This is an edited version specifically for CDSonic
						If you want to play this mod with other characters, please go download their mod from
								https://mb.srb2.org/addons/classic-based-physics-changes.6399/
*/

COM_AddCommand("cdphysicstoggle", function(player)
	local mo = player.mo
	if not (mo or mo.valid)
	or mo.skin ~= "cdsonic"
		return
	end
	
	if P_IsObjectOnGround(mo)
	and (mo.state == S_PLAY_STND or mo.state == S_PLAY_WAIT)
		if player.physics == 1
			CONS_Printf(player, "Classic Physics have been toggled off for you")
			player.physics = 0
		else
			player.physics = 1
			CONS_Printf(player, "Classic Physics have been toggled on for you")
		end
	end
end)

addHook("PlayerThink",function(player)
	if not (player.mo or player.mo.valid)
	or player.mo.skin ~= "cdsonic"
		return
	end
	
	if player.physics == nil
		player.physics = 1
	end
	
	
	if player.physics == 0
		player.jumpfactor = skins[player.mo.skin].jumpfactor
		player.acceleration = skins[player.mo.skin].acceleration
		player.accelstart = skins[player.mo.skin].accelstart
		return
	end
	// GRAVITY CHANGES
	if not (player.mo.flags & MF_NOGRAVITY)
	and not (player.mo.flags & MF_NOTHINK)
	and not P_PlayerInPain(player)
	and abs(player.mo.momz)
	--and not P_IsObjectOnGround(player.mo)
		player.mo.momz = $+FixedMul(P_GetMobjGravity(player.mo), 3*FRACUNIT/4) -- current grav + 0.75 = 1 -- -- -- 9/20 = 0.45
	end
	if player.jumpfactor == skins[player.mo.skin].jumpfactor
		player.jumpfactor = FixedMul($, 3*FRACUNIT / 2) -- current jump * 1.5
	end

	if player.prevCarry and player.prevCarry == CR_MACESPIN then
		player.mo.momz = FixedMul($, 5*FRACUNIT / 4) -- current mace * 1.25
		player.mo.momx = FixedMul($, 7*FRACUNIT / 4) -- 1.75
		player.mo.momy = FixedMul($, 7*FRACUNIT / 4) -- 1.75
		--print("MACESPIN boost")
	end
	
	if player.prevCarry and player.prevCarry == CR_DUSTDEVIL then
		player.mo.momz = FixedMul($, 7*FRACUNIT / 5)-- current dustdevil * 1.4	
		--print("DUSTDEVIL boost")
	end

	player.prevCarry = player.powers[pw_carry]
	
	// FIX SPINNING SUCKING
	if (player.pflags & PF_SPINNING)
	and not P_IsObjectOnGround(player.mo)
		player.pflags = $|PF_JUMPED
		--print("FIX SPINNING SUCKING")
	end
		
	// FIX HALFPIPES
	//if (player.pflags & PF_SPINNING) 
	//and (player.pflags & PF_THOKKED) 
	//and not P_IsObjectOnGround(player.mo)
	//	player.pflags = $&~PF_THOKKED
		--print("FIX HALFPIPES")
	//end
	
	// FIX DSZ2
	if (player.mo.state == S_PLAY_ROLL)
	and player.powers[pw_justlaunched]
	--and (FixedHypot(player.rmomx, player.rmomy) >= 20*FRACUNIT)
		player.powers[pw_strong] = STR_ANIM|STR_WALL
		player.mo.momz = FixedMul($, 11*FRACUNIT / 10) -- current launch * 1.1
		--print("FIX DSZ2")
	end
	
	if player.accelstart -- == skins[player.mo.skin].accelstart
		player.accelstart = 56 -- current acceleration
	end
	
	if player.acceleration -- == skins[player.mo.skin].acceleration
	and not ((player.powers[pw_sneakers]) or (player.powers[pw_super]))
		player.acceleration = 28 -- current acceleration
	end
	
	if P_IsObjectOnGround(player.mo)
	and ((player.powers[pw_sneakers]) or (player.powers[pw_super]))
	and ((player.cmd.forwardmove) or (player.cmd.sidemove))
	and (FixedHypot(player.rmomx, player.rmomy) < 76*FRACUNIT)
		if (player.pflags & PF_STARTDASH)
		or player.mo.state == S_PLAY_DEAD
		or player.mo.state == S_PLAY_DRWN
			return
		end
		P_Thrust(player.mo, player.mo.angle, FRACUNIT/3)
	end
	
	-- fix air control
	/*if not P_IsObjectOnGround(player.mo)
	and not ((player.powers[pw_sneakers]) or (player.powers[pw_super]))
	and ((player.cmd.forwardmove) or (player.cmd.sidemove))
	and player.mo.state ~= S_PLAY_DEAD
	and player.mo.state ~= S_PLAY_DRWN
	and player.mo.state ~= S_PLAY_PAIN
	and player.mo.state ~= S_PLAY_GASP
	and (FixedHypot(player.rmomx, player.rmomy) < 36*FRACUNIT)
	and not (player.mo.eflags & MFE_UNDERWATER)
		P_Thrust(player.mo, player.mo.angle, FRACUNIT/5)
	end
	
	-- fix air control [speed]
	if not P_IsObjectOnGround(player.mo)
	and ((player.powers[pw_sneakers]) or (player.powers[pw_super]))
	and ((player.cmd.forwardmove) or (player.cmd.sidemove))
	and player.mo.state != S_PLAY_DEAD
	and player.mo.state != S_PLAY_DRWN
	and player.mo.state != S_PLAY_PAIN
	and player.mo.state != S_PLAY_GASP
	and (FixedHypot(player.rmomx, player.rmomy) < 56*FRACUNIT)
	and not (player.mo.eflags & MFE_UNDERWATER)
		P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT/5)
	end
	
	-- fix air control underwater
	if not P_IsObjectOnGround(player.mo)
	and ((player.cmd.forwardmove) or (player.cmd.sidemove))
	and player.mo.state != S_PLAY_DEAD
	and player.mo.state != S_PLAY_DRWN
	and player.mo.state != S_PLAY_PAIN
	and player.mo.state != S_PLAY_GASP
	and (FixedHypot(player.rmomx, player.rmomy) < 16*FRACUNIT)
	and (player.mo.eflags & MFE_UNDERWATER)
		P_Thrust(player.mo, player.mo.angle, FRACUNIT/10)
	end
	
	-- fix air control underwater [speed]
	if not P_IsObjectOnGround(player.mo)
	and ((player.powers[pw_sneakers]) or (player.powers[pw_super]))
	and ((player.cmd.forwardmove) or (player.cmd.sidemove))
	and player.mo.state != S_PLAY_DEAD
	and player.mo.state != S_PLAY_DRWN
	and player.mo.state != S_PLAY_PAIN
	and player.mo.state != S_PLAY_GASP
	and (FixedHypot(player.rmomx, player.rmomy) < 36*FRACUNIT)
	and (player.mo.eflags & MFE_UNDERWATER)
		P_Thrust(player.mo, player.mo.angle, FRACUNIT/5)
	end*/
end)

-- spring check
-- code by maril <3
addHook("MobjMoveCollide", function(mo, spring)
  if mo.skin ~= "cdsonic" then return end
  if mo.physics == 0 then return end
  if not (mo and mo.valid) then return end
  if not mo.health then return end
  if not (spring and spring.valid) then return end
  if mo.z + mo.height < spring.z or spring.z + spring.height < mo.z then return end  
  if not (spring.flags & MF_SPRING) then return end
  
	if spring.type ~= MT_YELLOWSPRING
	and spring.type ~= MT_REDSPRING
	and spring.type ~= MT_BLUESPRING
	and spring.type ~= MT_CDSPRING
	and spring.type ~= MT_CDHORIZ
		mo.player.horizboost = true
		--print("spring check [not a vertical spring]")
	end

	if spring.type ~= MT_YELLOWHORIZ
	and spring.type ~= MT_REDHORIZ
	and spring.type ~= MT_BLUEHORIZ
	and spring.type ~= MT_CDHORIZ
		mo.player.vertiboost = true
		--print("spring check [not a horizontal spring]")
	end
end, MT_PLAYER)

-- uses Fixed Multiplayer now

--spring check 2 [checks if its NOT a spring]
--also thanks amperbee <3

addHook("MobjMoveCollide", function(mo, spring)
	if mo.skin ~= "cdsonic" then return end
	if mo.physics == 0 then return end
	if not (mo and mo.valid) then return end
	if not mo.health then return end
	--if (spring and spring.valid) then return end
	--if mo.z + mo.height < spring.z or spring.z + spring.height < mo.z then return end  
	if not (spring.flags & MF_SPRING)
		mo.player.vertiboost = true
		--print("spring check 2 [checks if its NOT a spring]")
	end
end, MT_PLAYER)

addHook("ThinkFrame", do
    for player in players.iterate do
	if player.mo.skin ~= "cdsonic" then continue end
	if player.physics == 0 then continue end
	if (player.mo.eflags & MFE_SPRUNG)
        and player.horizboost then
            player.mo.momx = FixedMul($, 13*FRACUNIT / 10)
            player.mo.momy = FixedMul($, 13*FRACUNIT / 10)
				--print("horizontal boost")
            player.horizboost = false
        end

	if (player.mo.eflags & MFE_SPRUNG)
        and player.vertiboost then
            player.mo.momz = FixedMul($, 67*FRACUNIT / 50)
				--print("vertical boost")
            player.vertiboost = false
        end
    end
end)